Lattice Grid Buy a licence

svelte data grid · editing

Svelte Grid: Editing

Type into a cell, or edit a whole row as one transaction: both run through the same Grid.svelte component, shipped as source your own toolchain compiles, with every configuration key taken as a prop.

Also in: React Angular Vue

Install and import

Grid.svelte lives at @toclocoinc/lattice-grid/svelte/Grid.svelte, compiled by whichever Svelte your application already runs.

npm install @toclocoinc/lattice-grid
# svelte is an optional peer dependency: nothing extra installs
# on a project that is not using it
# free on localhost; a production domain needs a licence key (see /pricing/)

The files

CellEditing.svelte

<!-- CellEditing.svelte -->
<script>
  import Grid from '@toclocoinc/lattice-grid/svelte/Grid.svelte';
  import '@toclocoinc/lattice-grid/css';

  // edit on the grid switches editing on; edit on a column says which
  // columns take it. "circuit" carries no edit key below, so it stays
  // read-only even though editing is on for the grid as a whole.
  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
    { field: 'region', title: 'Region', edit: true },
    { field: 'status', title: 'Status', filter: { type: 'set' }, edit: true },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' }, edit: true },
    { field: 'charge', title: 'Monthly charge', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' }, edit: true },
  ];

  let rows = $state.raw([]); // circuit records
  let grid;
</script>

<Grid bind:this={grid} rowKey="id" selection="multiple" edit={true} {columns} {rows} style="height: 460px" />

RowEditing.svelte

<!-- RowEditing.svelte -->
<script>
  import Grid from '@toclocoinc/lattice-grid/svelte/Grid.svelte';

  // mode: 'row' opens the whole row for editing at once, as one
  // transaction, rather than one cell at a time.
  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
    { field: 'region', title: 'Region', edit: true },
    { field: 'status', title: 'Status', filter: { type: 'set' }, edit: true },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' }, edit: true },
    { field: 'charge', title: 'Monthly charge', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' }, edit: true },
  ];

  let rows = $state.raw([]); // circuit records
  const editConfig = { enabled: true, mode: 'row' };
</script>

<Grid rowKey="id" selection="multiple" edit={editConfig} {columns} {rows} style="height: 460px" />

See it running

Building…
Loading a live grid…

Open the plain-JS cell-editing demo →

Building…
Loading a live grid…

Open the plain-JS row-editing demo →

Working in Svelte

Reaching the grid. bind:this={grid} plus the component's own grid() export hands you the live instance, the same object createGrid itself would return; it is null until the component has mounted.

class, style and id go on the host; everything else is configuration. Every other prop you pass is diffed with Object.is and pushed through setAll on change, so hold rows in $state.raw (or a plain variable) and assign a new array when the data actually changes, never a deep $state proxy over it.

The use:lattice action still works. If you already own the element, use:lattice={config} is unchanged and does the same job with no component wrapper at all.

Related

Lattice Grid Buy a licence

react data grid · editing

React Grid: Editing

Type into a cell, edit a whole row as one transaction, or both on the same grid: the React component is a thin wrapper over the same edit pipeline the vanilla grid uses, so nothing about editing changes when you add React.

Also in: Angular Vue Svelte

Install and import

One package, no separate React package to version alongside it. createLatticeGrid is a named export of the react module and builds a component your JSX renders like any other; the licence line applies only once you deploy off localhost.

npm install @toclocoinc/lattice-grid
# free on localhost; a production domain needs a licence key (see /pricing/)

The files

lattice.ts

// lattice.ts, built once and shared by every component that mounts a grid
import React from 'react';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createLatticeGrid } from '@toclocoinc/lattice-grid/modules/react';

export const LatticeGrid = createLatticeGrid({ React, createGrid });

CellEditing.tsx

// CellEditing.tsx
import React from 'react';
import { createRoot } from 'react-dom/client';
import { LatticeGrid } from './lattice';

// edit on the grid switches editing on; edit on a column says which columns
// take it. "circuit" carries no edit key below, so it stays read-only even
// though editing is on for the grid as a whole.
const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', edit: true },
  { field: 'status', title: 'Status', filter: { type: 'set' }, edit: true },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' }, edit: true },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' }, edit: true },
];

const rows = [/* circuit records, one per line */];

function CellEditing() {
  const ref = React.useRef<{ grid: any } | null>(null);
  return (
    <LatticeGrid
      ref={ref}
      rowKey="id"
      selection="multiple"
      edit
      columns={columns}
      rows={rows}
      style={{ height: '460px' }}
    />
  );
}

createRoot(document.getElementById('cell-editing')!).render(<CellEditing />);

RowEditing.tsx

// RowEditing.tsx
import React from 'react';
import { createRoot } from 'react-dom/client';
import { LatticeGrid } from './lattice';

// mode: 'row' opens the whole row for editing at once, as one transaction,
// rather than one cell at a time.
const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', edit: true },
  { field: 'status', title: 'Status', filter: { type: 'set' }, edit: true },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' }, edit: true },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' }, edit: true },
];

const rows = [/* circuit records, one per line */];

function RowEditing() {
  return (
    <LatticeGrid
      rowKey="id"
      selection="multiple"
      edit={{ enabled: true, mode: 'row' }}
      columns={columns}
      rows={rows}
      style={{ height: '460px' }}
    />
  );
}

createRoot(document.getElementById('row-editing')!).render(<RowEditing />);

See it running

The live grid below runs the same configuration shown above; the React tab under it is the shown code, copyable as it stands.

Building…
Loading a live grid…

Open the cell-editing demo in React →

Building…
Loading a live grid…

Open the row-editing demo in React →

Working in React

Reaching the grid. Forward a ref onto <LatticeGrid> and, after mount, ref.current.grid is the live instance createGrid itself would have returned, the same object for grid.export, grid.selection or an imperative commit outside the edit pipeline shown above.

Hold your props steady. Change detection is reference equality, not a deep compare of a possibly million-row array. Build columns once outside the component (as above) or memoise it, and hand back a new rows array only when the data actually changed; an edited cell updates the grid through its own store, not by you replacing the array.

StrictMode is handled. React 18's development double-mount destroys the first grid in the effect cleanup and builds a second, so nothing leaks and nothing double-edits.

TypeScript. Column and config types resolve from the package automatically; there is no separate @types package to add.

Related

Lattice Grid Buy a licence

vue data grid · editing

Vue Grid: Editing

Type into a cell, or edit a whole row as one transaction: both run through the same LatticeGrid component, built once at module scope from createLatticeGrid and used like any other Vue component in your template.

Also in: React Angular Svelte

Install and import

createLatticeGrid is a named export of the vue module, built once and reused everywhere you need a grid; the licence line applies only once you deploy off localhost.

npm install @toclocoinc/lattice-grid
# free on localhost; a production domain needs a licence key (see /pricing/)

The files

lattice.js

// lattice.js, built once at module scope
import * as vue from 'vue';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createLatticeGrid } from '@toclocoinc/lattice-grid/modules/vue';

export const LatticeGrid = createLatticeGrid({ vue, createGrid });

CellEditing.vue

<!-- CellEditing.vue -->
<script setup>
import { LatticeGrid } from './lattice';

// edit on the grid switches editing on; edit on a column says which columns
// take it. "circuit" carries no edit key below, so it stays read-only even
// though editing is on for the grid as a whole.
const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', edit: true },
  { field: 'status', title: 'Status', filter: { type: 'set' }, edit: true },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' }, edit: true },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' }, edit: true },
];

const rows = []; // circuit records
</script>

<template>
  <LatticeGrid
    row-key="id"
    selection="multiple"
    edit
    :columns="columns"
    :rows="rows"
    style="height: 460px"
  />
</template>

RowEditing.vue

<!-- RowEditing.vue -->
<script setup>
import { LatticeGrid } from './lattice';

// mode: 'row' opens the whole row for editing at once, as one transaction,
// rather than one cell at a time.
const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', edit: true },
  { field: 'status', title: 'Status', filter: { type: 'set' }, edit: true },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' }, edit: true },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' }, edit: true },
];

const rows = []; // circuit records
const editConfig = { enabled: true, mode: 'row' };
</script>

<template>
  <LatticeGrid
    row-key="id"
    selection="multiple"
    :edit="editConfig"
    :columns="columns"
    :rows="rows"
    style="height: 460px"
  />
</template>

See it running

Building…
Loading a live grid…

Open this demo's Vue tab →

Building…
Loading a live grid…

Open this demo's Vue tab →

Working in Vue

Reaching the grid. A template ref on <LatticeGrid> exposes a grid() getter: this.$refs.grid.grid().export.toCsv() (or gridRef.value.grid() under <script setup>) is the live instance createGrid itself would have returned.

Props are diffed by identity. An inline :columns="[{ field: 'a' }]" is a new array every render and reconfigures the grid every render; hold columns at module scope or behind a computed, as the files above do.

Events are re-emitted under dashed names. cell:changed arrives as @cell-changed, because a colon in a Vue template binding is directive syntax, and every event is declared in emits, so none of them falls through to the host element.

Related

Lattice Grid Buy a licence

angular data grid · editing

Angular Grid: Editing

Type into a cell, or edit a whole row as one transaction: both run through the same standalone lattice-grid component, compiled ahead of time by your own build rather than assembled in the page.

Also in: React Vue Svelte

Install and import

Angular's components ship as an entry point inside the same package, at @toclocoinc/lattice-grid/angular, compiled by @angular/compiler-cli into a partial-Ivy library your own build links, with no JIT compiler needed in the page and no second package to keep in step with the grid's own version.

npm install @toclocoinc/lattice-grid
# @angular/core and @angular/common are optional peer dependencies:
# nothing extra installs on a non-Angular project
# free on localhost; a production domain needs a licence key (see /pricing/)

The files

cell-editing.component.ts

// cell-editing.component.ts
import { Component, viewChild } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { LatticeGridComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

// edit on the grid switches editing on; edit on a column says which columns
// take it. "circuit" carries no edit key below, so it stays read-only even
// though editing is on for the grid as a whole.
const COLUMNS = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', edit: true },
  { field: 'status', title: 'Status', filter: { type: 'set' }, edit: true },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' }, edit: true },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' }, edit: true },
];

@Component({
  selector: 'app-cell-editing',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<lattice-grid #grid [config]="config" (cell-changed)="onCellChanged($event)" ' +
    'style="display:block;height:460px"></lattice-grid>',
})
export class CellEditingComponent {
  grid = viewChild<LatticeGridComponent>('grid');
  config = {
    rowKey: 'id',
    selection: 'multiple',
    edit: true,
    columns: COLUMNS,
    rows: [] as unknown[], // circuit records
  };
  onCellChanged(e: unknown) { console.log('cell changed', e); }
}

bootstrapApplication(CellEditingComponent, {
  providers: [provideLattice({ createGrid })],
});

row-editing.component.ts

// row-editing.component.ts
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { LatticeGridComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

// mode: 'row' opens the whole row for editing at once, as one transaction,
// rather than one cell at a time.
const COLUMNS = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', edit: true },
  { field: 'status', title: 'Status', filter: { type: 'set' }, edit: true },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number', filter: { type: 'number' }, edit: true },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, filter: { type: 'number' }, edit: true },
];

@Component({
  selector: 'app-row-editing',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="config" style="display:block;height:460px"></lattice-grid>',
})
export class RowEditingComponent {
  config = {
    rowKey: 'id',
    selection: 'multiple',
    edit: { enabled: true, mode: 'row' },
    columns: COLUMNS,
    rows: [] as unknown[], // circuit records
  };
}

bootstrapApplication(RowEditingComponent, {
  providers: [provideLattice({ createGrid })],
});

See it running

Building…
Loading a live grid…

Open this demo's Angular tab →

Building…
Loading a live grid…

Open this demo's Angular tab →

Working in Angular

Reaching the grid. A template reference variable (#grid) plus a signal query (viewChild(LatticeGridComponent)) gets you the component; its own grid() getter is the live instance, the same object createGrid itself would return.

Inputs are compared by identity, and never rebuild the instance. A changed [config] reaches the grid already on screen through setAll; an inline object literal in the template is a new object on every change-detection pass, so hold config in a field, as both components do above, not inline in the template.

Events are outputs under their kebab-case name: cell:changed arrives as (cell-changed), and (grid-ready) hands you the instance the moment it exists, before any change-detection cycle has to run.

No zone assumptions. The grid is created outside NgZone, because it owns its own scroll and pointer handling; a bound output still re-enters the zone and repaints as expected, and this works the same under zoneless change detection.

Related